#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Fenrir TTY screen reader
# By Chrys, Storm Dragon, and contributors.

from fenrirscreenreader.core.i18n import _


class command:
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def get_description(self):
        return _("enables or disables tracking of highlighted text")

    def run(self):
        curr_mode = self.env["runtime"]["SettingsManager"].get_setting_as_bool(
            "focus", "highlight"
        )

        self.env["runtime"]["SettingsManager"].set_setting(
            "focus", "highlight", str(not curr_mode)
        )
        self.env["runtime"]["SettingsManager"].set_setting(
            "focus", "cursor", str(curr_mode)
        )
        if self.env["runtime"]["SettingsManager"].get_setting_as_bool(
            "focus", "highlight"
        ):
            self.env["runtime"]["OutputManager"].present_text(
                _("highlight tracking"), sound_icon="", interrupt=True
            )
        else:
            self.env["runtime"]["OutputManager"].present_text(
                _("cursor tracking"), sound_icon="", interrupt=True
            )

    def set_callback(self, callback):
        pass
