#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Fenrir TTY screen reader
# By Chrys, Storm Dragon, and contributors.

import re

from fenrirscreenreader.core import debug


class TableManager:
    def __init__(self):
        self.headLine = ""
        self.defaultSeparators = ["+", ";", "|", " "]
        self.noOfHeadLineColumns = 0
        self.headColumnSep = ""
        self.rowColumnSep = ""

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def reset_table_mode(self):
        self.set_head_line()

    def set_head_column_sep(self, columnSep=""):
        self.headColumnSep = columnSep
        if columnSep == "":
            self.noOfHeadLineColumns = 0
        else:
            self.coun_no_of_head_columns()

    def coun_no_of_head_columns(self):
        pass

    def search_for_head_column_sep(self, headLine):
        if " " in headLine:
            return " "
        return ""

    def set_row_column_sep(self, columnSep=""):
        self.rowColumnSep = columnSep

    def set_head_line(self, headLine=""):
        self.set_head_column_sep()
        self.set_row_column_sep()
        if headLine != "":
            sep = self.search_for_head_column_sep(headLine)
            if sep != "":
                self.headLine = headLine
                self.set_head_column_sep(sep)
